#include <stdio.h>
#include <signal.h>
#include <setjmp.h>

static sigjmp_buf out;

void sigill(int signal)
{
	siglongjmp(out, 1);
}

int main(void)
{
	int died;

	signal(SIGILL, sigill);

	died = sigsetjmp(out, 1);

	if (!died){
		asm volatile(
			"nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);"
			"nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);"
			"nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);"
			"nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);nopl 0(%eax);");
	}

	printf("Long NOPs supported: %s\n", died ? "no" : "yes");
	return died;
}
